'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n          @media (max-width: ', 'em) and (min-width: ', 'em) {\n            ', ';\n          }\n        '], ['\n          @media (max-width: ', 'em) and (min-width: ', 'em) {\n            ', ';\n          }\n        ']),
    _templateObject2 = _taggedTemplateLiteral(['\n          @media (max-width: ', 'em) {\n            ', ';\n          }\n        '], ['\n          @media (max-width: ', 'em) {\n            ', ';\n          }\n        ']),
    _templateObject3 = _taggedTemplateLiteral(['\n          @media (min-width: ', 'em) {\n            ', ';\n          }\n        '], ['\n          @media (min-width: ', 'em) {\n            ', ';\n          }\n        ']);

var _styledComponents = require('styled-components');

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } /*eslint-disable */


// define all devices by setting min and max where applicable, for devices where
// only min is set, then the media query rule will be 'min-width'. When only defining
// max, then the media query rule will be 'max-width'. If both are defined,
// then the media query rule will be 'max-width and min-width'.

var defaultBreakpoints = {
  phone: {
    max: 768
  },
  tablet: {
    min: 768,
    max: 1160
  },
  desktop: {
    min: 1160,
    max: 1400
  },
  large: {
    min: 1400
  }

  // iterate through the sizes and create a media template
};var mediaQuery = function mediaQuery(userBreakpoints) {
  var availableBreakpoints = userBreakpoints || defaultBreakpoints;
  var acumulatedMedia = Object.keys(availableBreakpoints).reduce(function (accumulator, obj) {
    // use em in breakpoints to work properly cross-browser and support users
    // changing their browsers font-size: https://zellwk.com/blog/media-query-units/
    var emSizeMin = availableBreakpoints[obj].min / 16;
    var emSizeMax = availableBreakpoints[obj].max / 16;
    accumulator[obj] = function () {
      if (emSizeMin && emSizeMax) {
        return (0, _styledComponents.css)(_templateObject, emSizeMax, emSizeMin, _styledComponents.css.apply(undefined, arguments));
      } else if (!emSizeMin && emSizeMax) {
        return (0, _styledComponents.css)(_templateObject2, emSizeMax, _styledComponents.css.apply(undefined, arguments));
      } else if (emSizeMin && !emSizeMax) {
        return (0, _styledComponents.css)(_templateObject3, emSizeMin, _styledComponents.css.apply(undefined, arguments));
      }
    };
    return accumulator;
  }, {});
  return acumulatedMedia;
};

exports.default = mediaQuery;